﻿using Buddy.Wildstar.Game.Actors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
 
 using Buddy.Coroutines;
 
using Buddy.Wildstar.Game;
 
namespace Buddy.DefaultRoutine.Classes
{
    public class SpellSlinger : BaseCombatClass
    {
        MyGadget Gadget = new MyGadget();
            internal override async Task<bool> Pull(Actor target)
        {
			await PopFlask();
            return await Combat();
        }
       
        internal override async Task<bool> Heal()
        {
 
            var lowestPercent = PartyMembers.OrderBy(p => p.HealthPercent).FirstOrDefault();
 
            if (!Me.HasBuff("Healing Salve") && await Cast("Healing Salve"))
                return true;
            if (!Me.HasBuff("Beacon") && await Cast("Affinity"))
                return true;
 
            if (lowestPercent == null)
                return false;
 
            var hPercent = lowestPercent.HealthPercent;
 
            if (hPercent < 90 && await CastOn("Runes of Protection", () => lowestPercent))
                return true;
            if (hPercent < 70 && await CastOn("Vitality Burst", () => lowestPercent))
                return true;
            if (hPercent < 90 && await CastOn("Astral Infusion", () => lowestPercent))
                return true;
            if (hPercent < 80 && await CastOn("Dual Fire", () => lowestPercent))
                return true;
            if (hPercent < 80 && await CastOn("Healing Torrent", () => lowestPercent))
                return true;
            if (hPercent < 30 && await CastOn("Voidspring", () => lowestPercent))
                return true;
            if (hPercent < 90 && await CastOn("Regenerative Pulse", () => lowestPercent))
                return true;
            if (hPercent < 70 && await CastOn("Sustain", () => lowestPercent))
                return true;
 
           
            return false;
        }
 
        internal override async Task<bool> Combat()
        {
                var resource = Me.Resources[4];
 
 			await ChugPotion();
 
 
 
               
                        if (Me.HealthPercent < 50 && await SelfCast("Void Slip"))
                return true;
               
            // Interrupt
            if (Target.IsCasting  && Target.IsInCombat && await CastAny("Spatial Shift", "Gate", "Arcane Shock"))
                return true;
 
            // Cleanse CC (Note, also breaks combat and resets NPCS
            //if (Me.HasCleansableCC() && await SelfCast("Void Slip"))
            //    return true;
 
            // Cleanse buffs
            if (Me.Buffs.Count(c => c.IsHarmful) > 0 && await Cast("Purify"))
                return true;
 
            // Maintain Target & self buffs
            if (await EnsureBuffs())
                return true;
                               
            if (Me.HealthPercent < 90 && await SelfCast("Runes of Protection"))
                return true;
			if (Me.HealthPercent < 90 && !Me.HasBuff("Runes of Protection") && await SelfCast("Astral Infusion"))
                return true;	
 
            // Handle innate ability
            //if (await HandleInnate())
            //    return true;
 
            if (!Me.HasBuff("Spell Surge") && Target.HealthPercent < 30 && await Cast("Assassinate"))
                return true;
 
            if (Me.HasBuff("Dealt Critical Damage") && await Cast("Flame Burst"))
                return true;
                               
 
                        if (await Cast("Flash Freeze"))
                return true;
				
						//Don't want to interrupt Charged Abilities if we're in the middle of casting them.
						if (CastingSpell("Charged Shot"))
						return true;
                               
            //TODO: Charged Shot
                       
                        //Uses a DPS gadget
                        if ((Gadget.GetType() == 1) && await Gadget.UseGadget())
                                return true;
									
                       
                        //Activates Spell Surge Ability when high levels of Spell Surge is available.
                        if ((!Me.HasBuff("Spell Surge") && resource >= 90) && await SelfCast("Spell Surge"))
                                return true;
                       
                       
                       
                        //If spell surge is down, and there exists a special available to use.  -> Turns spell surge on
                        if ((!Me.HasBuff("Spell Surge") &&
                        (IsSpellProcReady("Charged Shot") || IsSpellProcReady("Arcane Missiles") || IsSpellProcReady("Chill") || IsSpellProcReady("True Shot") || IsSpellProcReady("Rapid Fire") || IsSpellProcReady("Wild Barrage") || (HasSpell("Ignite") && !Target.HasBuff("Ignite"))))
                                && resource >= 25                                               //If no spell surge available, doesn't happen however.
                                && await SelfCast("Spell Surge") )
                return true;
 
			//Makes the bot use Charged Shot as a opener.
			if(!Me.IsInCombat && await Cast("Charged Shot"))
			{return true;}
 
                       
            //use a "special" attack.		
			//Bot seems to like spamming Ignite, as there seems to be a slight delay in the debuff applying.
			//We use a short sleep period to prevent this from happening.
			if (!Target.HasBuff("Ignite") && await Cast("Ignite"))
				{
				if (IsSpellTier("Ignite", 4)) //Reduced cast time (.5 seconds)
				{
				await Coroutine.Sleep(500);
				}
				else
				{
				await Coroutine.Sleep(1000); //Full cast time (1 second)
				}
                return true;}
			
            if (await CastAny("Charged Shot", "Arcane Missiles", "Chill", "True Shot", "Wild Barrage"))
                return true;
                               
                        if (IsSpellTier("Rapid Fire", 8) && Me.CanDash == true && !Me.HasBuff("Rapid Dasher") && IsSpellProcReady("Rapid Fire")) //Dashes for the tier 8 bonus
                        {
                                GameManager.Movement.Dash(Buddy.Wildstar.Game.DashDirection.Forward);
                                    return true;
                        }
                        else
                        {
                                       
                                if (await Cast("Rapid Fire"))
                                        return true;
                        }      
                               
                               
                               
                               
                               
                        //if spell surge is up, and quick draw is usable (not mid animation for a special for example), toggles it off
                        //However, it will remain on if we have a excess amount of spell surge available
                        //Me.InnateResource  currently does nothing
                        if ((Me.HasBuff("Spell Surge") && IsSpellProcReady("Quick Draw")) && (resource <= 50) && await SelfCast("Spell Surge"))
                                return true;
 
						//Uses excess surge on Assassinate charges.
						if (Target.HealthPercent >= 30 && Me.HasBuff("Spell Surge") && await Cast("Assassinate"))
							return true;
 
                        //Uses a non-surged quick draw if no specials are available.  
                        if (await CastAny("Quick Draw"))
                            return true;
 
            return false;
        }
 
        private async Task<bool> EnsureBuffs()
        {
 
               
            if (!Me.HasBuff("Empower") && await Cast("Void Pact"))
                return true;
            if (Me.HealthPercent < 85 && await SelfCast("Phase Shift"))
                return true;
 
            return false;
        }
 
        private async Task<bool> HandleInnate()
        {
            // Turn on or maintain Spell Surge
            if (!Me.HasBuff("Spell Surge") && await SelfCast("Spell Surge"))
                return true;
                               
            return false;
        }
    }
}