﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Buddy.DefaultRoutine.Classes
{
    public class Stalker : BaseCombatClass
    {
        internal override async Task<bool> Pull(Actor target)
        {
           // Note: All stalker innates, issue stealth. So we really don't care what stance we're in, we just want to get in stealth before we pull.
           if (!Me.HasBuff("Stealth") && await SelfCast(SpellManager.InnateAbility.Name))
               return true;

           return await base.Pull(target);
        }

        internal override async Task<bool> Combat()
        {
		
			await ChugPotion();
		
            // Interrupt 
            if (Target.IsCasting && Target.IsInCombat && await CastAny("Stagger", "False Retreat", "Pounce", "Tether Mine", "Collapse"))
                return true;

            // Ensure buffs on Target & self
            if (await EnsureBuffs())
                return true;

            // Concussive Kick cast when up
            if (!Me.HasBuff("Concussive Kicks - Cooldown") && await Cast("Concussive Kicks"))
                return true;

            // Remaining priority and casting 
            if (await CastAny("Impale", "Clone", "Analyze Weakness", "Ruin", "Cripple", "Nano Field", "Razor Disk", "Nano Virus", "Amplification Spike", "Frenzy", "Nano Dart", "Shred"))
                return true; 

            return false;
        }

        private async Task<bool> EnsureBuffs()
        {
			await PopFlask();
			
            if (!Target.HasBuff("Wound") && await Cast("Phlebotomize"))
                return true;

            if (!Target.HasCC(CCStateType.Taunt) && await Cast("Reaver"))
                return true;

            if (!Me.HasBuff("Punish") && await Cast("Punish"))
                return true; 
            if (!Me.HasBuff("Neutralize") && await Cast("Neutralize"))
                return true;
            if (!Me.HasBuff("Lifesteal") && await Cast("Bloodthirst"))
                return true;
            if (!Me.HasBuff("Defense") && (await Cast("Preperation") || await Cast("Steadfast")))
                return true;
            if (!Me.HasBuff("Weaken") && await Cast("Decimate"))
                return true; 

            return false;
        }
    }
}
